; This file defines and runs a procedure that reads
; expressions from a file, evaluates them, and writes
; the results back out to another file.

(load "evaluator.scm")

; read, evaluate, print loop

(define (repl iport oport)
  (let ((obj (read iport)))
    (if (not (eof-object? obj))
        (begin 
          (write obj oport)
          (display " => " oport)
          (display (evaluator obj) oport)
          (newline oport)
          (repl iport oport)
          ))))

(define (evaluate-items-from-file ifn ofn)
  (if (file-exists? ofn)
      (delete-file ofn))
  (let 
      ((ip (open-input-file ifn))
       (op (open-output-file ofn)))
    (repl ip op)
    (close-input-port ip)
    (close-output-port op)))

(evaluate-items-from-file "file-evaluator-input.txt" "file-evaluator-output.txt")
